#include <AppKit/AppKit.h>

@implementation NSPopUpButtonCell(Foo)
- (BOOL) usesPreferredEdge
{
  return NO; 
}
@end



@interface Foo : NSObject
{
  NSWindow *_win;
}
- (void) applicationWillFinishLaunching:(id)sth;

@end

@implementation Foo 
- (void) applicationWillFinishLaunching:(id)sth;
{
  NSPopUpButton *pop;
  _win = [[NSWindow alloc] initWithContentRect:NSMakeRect(200,300,400,300)
	  			styleMask: NSTitledWindowMask
				backing:NSBackingStoreBuffered
				defer:NO];
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(8,8,88,88) pullsDown:YES];
  [[pop cell] setBezelStyle:NSRegularSquareBezelStyle];
  [[pop cell] setUsesItemFromMenu:NO];
  [pop setPreferredEdge: NSMaxYEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MaxYEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);

  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(175+16,8,88,88) pullsDown:YES];
  [[pop cell] setUsesItemFromMenu:NO];
  [pop setPreferredEdge: NSMinYEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MinYEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);
  
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(8,175+16,88,88) pullsDown:YES];
  [[pop cell] setUsesItemFromMenu:NO];
  [pop setPreferredEdge: NSMaxXEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MaxXEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);
  
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(175+16,175+16,88,88) pullsDown:YES];
  [[pop cell] setUsesItemFromMenu:NO];
  [pop setPreferredEdge: NSMinXEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MinXEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);
  
  /* PullDown uses item from menu.. */ 
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(275+16,175+16,88,88) pullsDown:YES];
  [pop setPreferredEdge: NSMinXEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MinXEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);
  
  /* PullDown uses item from menu.. */ 
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(275+16,8,88,88) pullsDown:YES];
  [pop setPreferredEdge: NSMaxYEdge];
  [[pop cell] setMenuItem:AUTORELEASE([[NSMenuItem alloc] initWithTitle:@"MaxYEdge" action:(SEL)nil keyEquivalent:@""])];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ack"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(pop);
  
 {
  NSMenuItem *mi = [[NSMenuItem alloc] initWithTitle:@"with image" action:(SEL)nil keyEquivalent:@""];	
  /* PullDown uses item from menu.. */ 
  pop = [[NSPopUpButton alloc] initWithFrame:NSMakeRect(88+8,8,88,88) pullsDown:YES];
  [[pop cell] setMenuItem:mi];
  [[pop cell] setUsesItemFromMenu:NO];
  [pop setPreferredEdge: NSMinXEdge];
  [mi setImage:[NSImage imageNamed:@"GNUstep"]];
  [mi setOnStateImage:[NSImage imageNamed:@"GNUstep"]];
  [mi setState:NSOnState];
  [[_win contentView] addSubview:pop];
  [pop addItemWithTitle:@"ahhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh"];
  [pop addItemWithTitle:@"we've"];
  [pop addItemWithTitle:@"been"];
  [pop addItemWithTitle:@"burgled"];
  RELEASE(mi);
  RELEASE(pop);
 }
  
  [_win makeKeyAndOrderFront:self];
}
- (void) popUpAction:(id)sender
{
  NSLog(@"%@ %@", sender, [sender selectedItem]);  
}
@end
int main()
{
  NSAutoreleasePool *pool = [NSAutoreleasePool new];

  [NSApplication sharedApplication];
  [NSApp setDelegate:[Foo new]];
  [NSApp run];
  DESTROY(pool);
  return 0;
}
